<template>
  <MainTemplate>
    <template #topBar>
      <div class="flex flex-row items-center justify-between pt-5 pb-3 px-7">
        <h1 class="font-bold text-xl h-8">Mitglieder</h1>
      </div>
    </template>
    <template #diffMain>
      <div class="flex flex-col w-full h-full gap-2 justify-center px-7">
        <Pagination
          :items="members"
          :totalCount="totalCount"
          :indicateLoading="loading == 'loading'"
          @load-data="(offset, count, search) => fetchMembers(offset, count)"
          @search="(search) => fetchMembers(0, 25, true)"
        >
          <template #pageRow="{ row }: { row: MemberViewModel }">
            <MemberListItem :member="row" />
          </template>
        </Pagination>

        <div class="flex flex-row gap-4">
          <button v-if="can('create', 'club', 'member')" primary class="!w-fit" @click="openCreateModal">
            Mitglied erstellen
          </button>
        </div>
      </div>
    </template>
  </MainTemplate>
</template>

<script setup lang="ts">
import { defineAsyncComponent, defineComponent, markRaw } from "vue";
import { mapActions, mapState } from "pinia";
import MainTemplate from "@/templates/Main.vue";
import { ChevronRightIcon, ChevronLeftIcon } from "@heroicons/vue/20/solid";
import { useMemberStore } from "@/stores/admin/member";
import MemberListItem from "@/components/admin/club/member/MemberListItem.vue";
import { useModalStore } from "@/stores/modal";
import Pagination from "@/components/Pagination.vue";
import type { MemberViewModel } from "@/viewmodels/admin/member.models";
import { useAbilityStore } from "@/stores/ability";
</script>

<script lang="ts">
export default defineComponent({
  data() {
    return {
      currentPage: 0,
      maxEntriesPerPage: 25,
    };
  },
  computed: {
    ...mapState(useMemberStore, ["members", "totalCount", "loading"]),
    ...mapState(useAbilityStore, ["can"]),
  },
  mounted() {
    this.fetchMembers(0, this.maxEntriesPerPage, true);
  },
  methods: {
    ...mapActions(useMemberStore, ["fetchMembers"]),
    ...mapActions(useModalStore, ["openModal"]),
    openCreateModal() {
      this.openModal(
        markRaw(defineAsyncComponent(() => import("@/components/admin/club/member/CreateMemberModal.vue")))
      );
    },
  },
});
</script>
